/*
    Synth Lua - Formant speech synthesizer
    Copyright (C) 2013 Belousov Oleg <belousov.oleg@gmail.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "tract.h"
#include "frication.h"
#include "sin.h"
#include "noise.h"

int tract_fa = 0;
int tract_ff = 0;

static unsigned int 	phase = 0;
static int		prev_f = 0;

void frication_render(int *x) {
    int index = (phase >> 8) % 1024;
    int turb = (noise() - (1<<31)) >> 18;
    int f = (sin_table[index] + turb);

    /* soft low-pass filter */

    f += (prev_f >> 1) + (prev_f >> 2);		/* prev_f * 0.75 */
    prev_f = f;

    *x += f * 64 * tract_fa;

    phase += ((tract_ff + (noise() >> 20)) << 8) * 1024 / RATE;
}
