/*
    Synth Lua - Formant speech synthesizer
    Copyright (C) 2013 Belousov Oleg <belousov.oleg@gmail.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "tract.h"
#include "glotal.h"
#include "cordic.h"
#include "glotal_table.h"
#include "sin.h"

int tract_gf = 0;
int tract_ga = 0;
int tract_vp = 0;
int tract_vr = 0;

static unsigned int gphase = 0;
static unsigned int vphase = 0;

void glotal_render(int *x) {
    int vindex = (vphase >> 8) % SIN_SIZE;
    int vib = sin_table[vindex] * tract_vp;

    int index = ((gphase + vib ) >> 8) % GLOTAL_SAMPLES;

    *x += glotal_table[index] * tract_ga * GLOTAL_SCALE;

    gphase += (tract_gf << 8 ) * GLOTAL_SAMPLES / RATE;
    vphase += (tract_vr << 8 ) * GLOTAL_SAMPLES / RATE;
}
