/*
    Synth Lua - Formant speech synthesizer
    Copyright (C) 2013 Belousov Oleg <belousov.oleg@gmail.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "tract.h"
#include "nasal.h"
#include "cordic.h"

int tract_nf = 0;
int tract_na = 0;

static int nx = 0;

void nasal_render(int *x, int *y) {
    volatile long long t2;
    volatile int nf = CORDIC_HALF_PI / RATE * 4 * tract_nf;

    nx += *x;

    cordic(nf, y, x, 32);

    t2 = *x;
    t2 *= tract_na;
    t2 >>= 8;

    *x = nx;
    nx = -t2;
}
