/*
    Synth Lua - Formant speech synthesizer
    Copyright (C) 2013 Belousov Oleg <belousov.oleg@gmail.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "tract.h"
#include "noise.h"
#include "cordic.h"
#include "formant.h"
#include "glotal.h"
#include "nasal.h"
#include "frication.h"

int tract_rate = 44100;
int tract_aa = 0;

static int prev_aa = 0;

int tract_render() {
    int x, y = 0;

    x = noise() >> 17;

    /* soft low-pass filter */

    x += (prev_aa >> 1) + (prev_aa >> 2);	/* prev_aa * 0.75 */
    prev_aa = x;

    x *= tract_aa;
    x >>= 8;

    glotal_render(&x);
    formant_render(&x, &y);
    nasal_render(&x, &y);
    frication_render(&x);

    return x;
}
