#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#define SIZE	1024
double table[SIZE];

int main() {
    int		fd = open("test.raw", O_WRONLY | O_CREAT, 0644);
    double 	x, y, min = 100000.0, max = -100000.0;
    int		out;
    int		i;

    for (i = 0; i < SIZE; i++) {
	x = (double) i / SIZE;
	y = 3*x*x - 4*x*x*x;

	table[i] = y;

	if (y > max) max = y;
	if (y < min) min = y;
    }

    double scale = (max-min);
    double shift = (max+min)/2;

    for (i = 0; i < SIZE; i++) {
	out = (table[i] - shift ) / scale * (1 << 16);
	
	printf("%i, ", out);

	if ((i+1) % 10 == 0) printf("\n   ");

	// write(fd, &out, sizeof(out));
    }

    return 0;
}